SystemOrganization addCategory: #ConfigurationOfSnapshotcello!

Object subclass: #ConfigurationOfSnapshotcello
	instanceVariableNames: 'project'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ConfigurationOfSnapshotcello'!

!ConfigurationOfSnapshotcello commentStamp: '<historical>' prior: 0!
self loadDevelopment.

self loadStable.!

!ConfigurationOfSnapshotcello class methodsFor: 'private' stamp: 'TudorGirba 7/21/2013 23:25'!
ensureMetacello
        "Bootstrap Gofer (if necessary), load latest mcz file for ConfigurationOfMetacello (using old 
         Gofer API), then load the latest version of Metacello itself."

        Smalltalk at: #MetacelloProject ifAbsent: [ | error |
                "list of repositories to try, in case primary repository is not accessible"
                (Array 
                        with: 'http://www.squeaksource.com/MetacelloRepository' 
                        with: 'http://seaside.gemstone.com/ss/metacello') do: [:repositoryUrl |
                                ([
                                        Smalltalk at: #Gofer ifAbsent: [
                                        "Current version of Gofer from which to bootstrap - as of 1.0-beta.21"
                                                self bootstrapPackage: 'Gofer-Core-lr.115' from: repositoryUrl ].
                                        Smalltalk at: #Gofer ifPresent: [:goferClass | | gofer |
                                                gofer := goferClass new
                                                        url: repositoryUrl;
                                                        yourself.
                                                [ gofer addPackage: 'ConfigurationOfMetacello' ] on: Warning do: [:ex | ex resume ].
                                                gofer load ]]
                                                        on: Error
                                                        do: [ :ex |
                                                                error := ex.
                                                                Transcript 
                                                                        cr; 
                                                                        show: 'failed ensureMetacello: ';
                                                                        show: ex description printString;
                                                                        show: '...retrying'.
                                                                "try again"
                                                                ex return: nil ]) ~~ nil
                                        ifTrue: [
                                                "load 'default' group of Metacello"
                                                (Smalltalk at: #ConfigurationOfMetacello) perform: #load.
                                                ^self ]].
                "shouldn't get here unless the load failed ... throw an error"
                self error: 'retry with alternate repository failed: ', error description printString ]! !

!ConfigurationOfSnapshotcello class methodsFor: 'metacello tool support' stamp: 'TudorGirba 7/21/2013 23:25'!
isMetacelloConfig
	"Answer true and the Metacello tools will operate on you"
	
	^true! !

!ConfigurationOfSnapshotcello class methodsFor: 'loading' stamp: 'TudorGirba 7/21/2013 23:25'!
loadDevelopment
	(self project version: #development) load! !

!ConfigurationOfSnapshotcello class methodsFor: 'loading' stamp: 'TudorGirba 7/25/2013 20:18'!
loadStable
	(self project version: #stable) load! !

!ConfigurationOfSnapshotcello class methodsFor: 'accessing' stamp: 'TudorGirba 7/21/2013 23:25'!
project

	^self new project! !

!ConfigurationOfSnapshotcello methodsFor: 'baselines' stamp: 'TudorGirba 7/21/2013 23:26'!
baseline10: spec 
	<version: '1.0-baseline'>
	
	spec for: #common do: [
		spec blessing: #baseline.
		spec repository: 'http://www.smalltalkhub.com/mc/girba/Snapshotcello/main'.
		spec package: 'Snapshotcello' ]! !

!ConfigurationOfSnapshotcello methodsFor: 'symbolic' stamp: 'TudorGirba 7/21/2013 23:26'!
development: spec
	<symbolicVersion: #'development'>

	spec for: #'common' version: '1.0-baseline'! !

!ConfigurationOfSnapshotcello methodsFor: 'snapshots' stamp: 'TudorGirba 7/22/2013 23:07'!
populateSpec: aSpec with: list
	"generated by Snapshotcello
	
	creates a spec object for the package and the version stored in the list"
	
	list do: [:each |
		aSpec package: each third with: [
			aSpec file: (each first  copyUpToLast: $. ).
			aSpec repository: each second ] ]! !

!ConfigurationOfSnapshotcello methodsFor: 'accessing' stamp: 'TudorGirba 7/21/2013 23:25'!
project

	^ project ifNil: [ | constructor |
		"Bootstrap Metacello if it is not already loaded"
		self class ensureMetacello.
		"Construct Metacello project"
		constructor := (Smalltalk at: #MetacelloVersionConstructor) on: self.
		project := constructor project.
		project]! !

!ConfigurationOfSnapshotcello methodsFor: 'snapshots' stamp: 'TudorGirba 7/22/2013 23:07'!
snapshot1
	"generated by Snapshotcello"

	^ #( 
		#('Snapshotcello-TudorGirba.9.mcz'  'http://www.smalltalkhub.com/mc/girba/Snapshotcello/main/'  'Snapshotcello' ) 
	)! !

!ConfigurationOfSnapshotcello methodsFor: 'snapshots' stamp: 'TudorGirba 7/25/2013 20:19'!
snapshot2
	"generated by Snapshotcello"

	^ #( 
		#('Snapshotcello-TudorGirba.12.mcz'  'http://www.smalltalkhub.com/mc/girba/Snapshotcello/main/'  'Snapshotcello' ) 
	)! !

!ConfigurationOfSnapshotcello methodsFor: 'snapshots' stamp: 'TudorGirba 7/30/2013 22:12'!
snapshot3
	"generated by Snapshotcello"

	^ #( 
		#('Snapshotcello-TudorGirba.18.mcz'  'http://www.smalltalkhub.com/mc/girba/Snapshotcello/main/'  'Snapshotcello' ) 
	)! !

!ConfigurationOfSnapshotcello methodsFor: 'snapshots' stamp: 'TudorGirba 7/30/2013 22:22'!
snapshot4
	"generated by Snapshotcello"

	^ #( 
		#('Snapshotcello-TudorGirba.19.mcz'  'http://www.smalltalkhub.com/mc/girba/Snapshotcello/main/'  'Snapshotcello' ) 
	)! !

!ConfigurationOfSnapshotcello methodsFor: 'symbolic' stamp: 'TudorGirba 7/30/2013 22:22'!
stable: spec
	<symbolicVersion: #'stable'>

	spec for: #'common' version: '1.1-snapshot'.

	spec for: #'pharo2.x' version: '1.3-snapshot'.
! !

!ConfigurationOfSnapshotcello methodsFor: 'snapshot versions' stamp: 'TudorGirba 7/22/2013 23:07'!
version10snapshot: spec
	"generated by Snapshotcello"
	<version: '1.0-snapshot'>

	spec for: #common do: [
		self populateSpec: spec with: self snapshot1 ]! !

!ConfigurationOfSnapshotcello methodsFor: 'snapshot versions' stamp: 'TudorGirba 7/25/2013 20:19'!
version11snapshot: spec
	"generated by Snapshotcello"
	<version: '1.1-snapshot'>

	spec for: #common do: [
		self populateSpec: spec with: self snapshot2 ]! !

!ConfigurationOfSnapshotcello methodsFor: 'snapshot versions' stamp: 'TudorGirba 7/30/2013 22:12'!
version12snapshot: spec
	"generated by Snapshotcello"
	<version: '1.2-snapshot'>

	spec for: #common do: [
		self populateSpec: spec with: self snapshot3 ]! !

!ConfigurationOfSnapshotcello methodsFor: 'snapshot versions' stamp: 'TudorGirba 7/30/2013 22:22'!
version13snapshot: spec
	"generated by Snapshotcello"
	<version: '1.3-snapshot'>

	spec for: #common do: [
		self populateSpec: spec with: self snapshot4 ]! !
